/*
Techrm's calculator
created  July 2015
by Ricardo Medda and Giovanni Pintus
visit our blog http://techrm.blogspot.it/ or Instructables page http://www.instructables.com/member/techrm
*/

// include the library code:
#include <LiquidCrystal.h>

#define key0 30
#define key1 31
#define key2 32
#define key3 33
#define key4 34
#define key5 35
#define key6 36
#define key7 37
#define key8 38
#define key9 39
#define DEL  28
#define ENTER 29
#define MAXVALUE 99999

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

long number_1 = 0;
long number_2 = 0;
int control = 0;
boolean error = false;
long result = 0;
float result_div = 0.0;

void insertNumb () {
  for (int i = 0; i <= 9; i++) {
    //whithout this delay, the selection button pressed could become the first digit
    delay (200);
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("FIRST NUMBER");
    control = readKey ();
    //statement needed to catch the first digit
    if ( i == 0 ) {
      //statement needed to check if the pressed button is the special key OK
      //if yes "i" becomes 5 and the algorithm goes to the next for loop
      if ( control == 11 ) {
        i = 5;
      }
      //statement needed to check if the pressed button is the special key DEL
      //if yes "i" becomes 10 and the algorithm goes from both for loops
      //resetting the calculator
      else if ( control == 10) {
        i = 10;
        error = true;
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("CANCELLED!");
        delay(2000);
      }
      else {
        //stores the most significant digit
        number_1 = control;
        lcd.clear();
        lcd.setCursor(0, 1);
        lcd.print(control);
        delay(500);
      }
    }
    //statement needed to catch the remaining four digits
    //the following conditional statements have the same purpose of the ones described above
    else {
      if ( control == 11 ) {
        i = 5;
      }
      else if ( control == 10) {
        i = 10;
        error = true;
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("CANCELLED!");
        delay(2000);
      }
      else {
        number_1 = (number_1 * 10) + control;
        //check if number_1 is negative or is greater than MAXVALUE printing an error if yes
        if ((number_1 < 0) || (number_1 > MAXVALUE)) {
          error = true;
          i = 10;
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("ERROR!");
          lcd.setCursor(0, 1);
          lcd.print("MAX VALUE " + (String)MAXVALUE);
          delay(2000);
        }
        else {
          lcd.clear();
          lcd.setCursor(0, 1);
          lcd.print(control);
          lcd.setCursor(0, 0);
          lcd.print(number_1);
          delay(500);
        }
      }
    }
    if (i >= 4 && i <= 9) {
      //the following for loop catches the digits of the second number
      //and basically does the same thing as the previous one
      for (int j = 0; j <= 4; j++) {
        delay (200);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("SECOND NUMBER");
        control = readKey ();
        i++;
        if ( j == 0 ) {
          if ( control == 11 ) {
            i = 10;
            j = 5;
          }
          else if ( control == 10 ) {
            error = true;
            j = 5;
            i = 10;
            lcd.clear();
            lcd.setCursor(0, 0);
            lcd.print("CANCELLED!");
            delay(2000);
          }
          else {
            number_2 = control;
            lcd.clear();
            lcd.setCursor(0, 1);
            lcd.print(control);
            delay(500);
          }
        }
        else {
          if ( control == 11 ) {
            j = 5;
            i = 10;
          }
          else if ( control == 10 ) {
            error = true;
            j = 5;
            i = 10;
            lcd.clear();
            lcd.setCursor(0, 0);
            lcd.print("CANCELLED!");
            delay(2000);
          }
          else {
            number_2 = (number_2 * 10) + control;
            //check if number_2 is negative or is greater than MAXVALUE printing an error if yes
            if ((number_2 < 0) || (number_2 > MAXVALUE)) {
              error = true;
              j = 5;
              i = 10;
              lcd.clear();
              lcd.setCursor(0, 0);
              lcd.print("ERROR!");
              lcd.setCursor(0, 1);
              lcd.print("MAX VALUE " + (String)MAXVALUE);
              delay(2000);
            }
            else {
              lcd.clear();
              lcd.setCursor(0, 1);
              lcd.print(control);
              lcd.setCursor(0, 0);
              lcd.print(number_2);
              delay(500);
            }
          }
        }
      }
    }
  }

}

void wait () {
  while (digitalRead(key0) == LOW &&
         digitalRead(key1) == LOW &&
         digitalRead(key2) == LOW &&
         digitalRead(key3) == LOW &&
         digitalRead(key4) == LOW &&
         digitalRead(key5) == LOW &&
         digitalRead(key6) == LOW &&
         digitalRead(key7) == LOW &&
         digitalRead(key8) == LOW &&
         digitalRead(key9) == LOW &&
         digitalRead(DEL) == LOW &&
         digitalRead(ENTER) == LOW
        );
}

void setup() {
  //initializes push-buttons
  pinMode(key0, INPUT);
  pinMode(key1, INPUT);
  pinMode(key2, INPUT);
  pinMode(key3, INPUT);
  pinMode(key4, INPUT);
  pinMode(key5, INPUT);
  pinMode(key6, INPUT);
  pinMode(key7, INPUT);
  pinMode(key8, INPUT);
  pinMode(key9, INPUT);
  pinMode(DEL, INPUT);
  pinMode(ENTER, INPUT);  
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
}

int readKey () {
  wait();
  int operand = 0;
  if (digitalRead(key0) == HIGH) {
    operand = 0;
  }
  else if (digitalRead(key1) == HIGH) {
    operand = 1;
  }
  else if (digitalRead(key2) == HIGH) {
    operand = 2;
  }
  else if (digitalRead(key3) == HIGH) {
    operand = 3;
  }
  else if (digitalRead(key4) == HIGH) {
    operand = 4;
  }
  else if (digitalRead(key5) == HIGH) {
    operand = 5;
  }
  else if (digitalRead(key6) == HIGH) {
    operand = 6;
  }
  else if (digitalRead(key7) == HIGH) {
    operand = 7;
  }
  else if (digitalRead(key8) == HIGH) {
    operand = 8;
  }
  else if (digitalRead(key9) == HIGH) {
    operand = 9;
  }
  else if (digitalRead(DEL) == HIGH) {
    operand = 10;
  }
  else if (digitalRead(ENTER) == HIGH) {
    operand = 11;
  }
  delay(100);  
  return operand;
}

//SUM function
long sum (long number_1, long number_2) {
  return number_1 + number_2;
}

//SUBtraction function
long subtraction (long number_1, long number_2) {
  return number_1 - number_2;
}

//MULtiplication function
long multiplication (long number_1, long number_2) {
  return number_1 * number_2;
}

//DIVsion FUNCTION
float division (long number_1, long number_2) {
  return (float)number_1 / (float)number_2;
}

void loop() {
  number_1 = 0;
  number_2 = 0;
  delay (200);
//asks which calculation you want to do  
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("SUM,SUB,MUL,DIV");
  lcd.setCursor(0, 1);
  lcd.print("0  ,1  ,2  ,3  ");
//waits into the following loop till the user press a key
  wait();
  //"operation" is the variable needed to control the flow of the sketch
  int operation = readKey();
//SUM
  if (operation == 0) {
    insertNumb();
    if (error == true) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
    }
    else {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
      lcd.setCursor(0, 1);
      lcd.print("SUM = ");
      lcd.setCursor(7, 1);
      result = sum(number_1, number_2);
      if (result < MAXVALUE) {
        lcd.print(result);
      } else {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("ERROR!");
        lcd.setCursor(0, 1);
        lcd.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("DEL TO CONTINUE");
      }
    }
    while (readKey() != 10);
  }
  else if (operation == 1) {
    insertNumb();
    if (error == true) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
    } else {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
      lcd.setCursor(0, 1);
      lcd.print("SUB = ");
      lcd.setCursor(7, 1);
      result = subtraction(number_1, number_2);
      if (result < MAXVALUE) {
        lcd.print(result);
      } else {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("ERROR!");
        lcd.setCursor(0, 1);
        lcd.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("DEL TO CONTINUE");
      }
    }
    while (readKey() != 10);
  }
  else if (operation == 2) {
    insertNumb();
    if (error == true) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
    } else {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
      lcd.setCursor(0, 1);
      lcd.print("MUL = ");
      lcd.setCursor(7, 1);
      result = multiplication(number_1, number_2);
      if (result < MAXVALUE) {
        lcd.print(result);
      } else {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("ERROR!");
        lcd.setCursor(0, 1);
        lcd.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("DEL TO CONTINUE");
      }
    }
    while (readKey() != 10);
  }
  else if (operation == 3)  {
    insertNumb();
    if (error == true) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
    } else {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("DEL TO CONTINUE");
      lcd.setCursor(0, 1);
      lcd.print("DIV = ");
      lcd.setCursor(7, 1);
      result_div = division(number_1, number_2);
      if (result < MAXVALUE) {
        lcd.print(result_div, 7);
      } else {
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("ERROR!");
        lcd.setCursor(0, 1);
        lcd.print("MAX VALUE " + (String)MAXVALUE);
        delay(4000);
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("DEL TO CONTINUE");
      }
    }
    while (readKey() != 10);
  } else {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("ERROR!");
    lcd.setCursor(0, 1);
    lcd.print("PRESS 0,1,2 or 3");
    delay(2000);
  }
  int  control = 0;

}
